Loading...
Searching...
No Matches
casacore::ForwardColumn Class Reference
tables package (libcasa_tables) » DataMan_module » DataMan_module_internal_classes

More...

`#include <ForwardCol.h>`

## Public Member Functions

| ForwardColumn (ForwardColumnEngine *enginePtr, const String &columnName, int dataType, const String &dataTypeId, const Table &referencedTable)
| Construct it for the given column.
virtual | ~ForwardColumn ()
| Destructor is mandatory.
| ForwardColumn (const ForwardColumn &)=delete
| Copy constructor is not needed and therefore forbidden.
ForwardColumn & | operator= (const ForwardColumn &)=delete
| Assignment is not needed and therefore forbidden.
void | fillTableName (const Table &thisTable, const Table &referencedTable)
| Define the special keyword containing the name of the original table.
virtual void | prepare (const Table &thisTable)
| Initialize the object.
void | setRW ()
| Set the column to writable if its underlying table is writable.
Public Member Functions inherited from casacore::DataManagerColumn
| DataManagerColumn ()
| Create a column.
virtual | ~DataManagerColumn ()
| Frees up the storage.
| DataManagerColumn (const DataManagerColumn &)=delete
| The copy constructor cannot be used for this base class.
DataManagerColumn & | operator= (const DataManagerColumn &)=delete
| Assignment cannot be used for this base class.
void | setIsFixedShape (Bool isFixedShape)
| Set the isFixedShape flag.
Bool | isFixedShape () const
| Is this a fixed shape column?
virtual void | setMaxLength (uInt maxLength)
| Set the maximum length of the value (can be used for strings).
void | setFixedShapeColumn (const IPosition &shape)
| Set the shape of all (fixed-shaped) arrays in the column.
virtual void | setShapeTiled (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of an (variable-shaped) array in the given row.
virtual IPosition | tileShape (rownr_t rownr)
| Get the tile shape of the item in the given row.
ColumnCache & | columnCache ()
| Get access to the ColumnCache object.
const ColumnCache * | columnCachePtr () const
void | get (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
void | get (rownr_t rownr, uChar *dataPtr)
void | get (rownr_t rownr, Short *dataPtr)
void | get (rownr_t rownr, uShort *dataPtr)
void | get (rownr_t rownr, Int *dataPtr)
void | get (rownr_t rownr, uInt *dataPtr)
void | get (rownr_t rownr, Int64 *dataPtr)
void | get (rownr_t rownr, float *dataPtr)
void | get (rownr_t rownr, double *dataPtr)
void | get (rownr_t rownr, Complex *dataPtr)
void | get (rownr_t rownr, DComplex *dataPtr)
void | get (rownr_t rownr, String *dataPtr)
void | get (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
void | put (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
void | put (rownr_t rownr, const uChar *dataPtr)
void | put (rownr_t rownr, const Short *dataPtr)
void | put (rownr_t rownr, const uShort *dataPtr)
void | put (rownr_t rownr, const Int *dataPtr)
void | put (rownr_t rownr, const uInt *dataPtr)
void | put (rownr_t rownr, const Int64 *dataPtr)
void | put (rownr_t rownr, const float *dataPtr)
void | put (rownr_t rownr, const double *dataPtr)
void | put (rownr_t rownr, const Complex *dataPtr)
void | put (rownr_t rownr, const DComplex *dataPtr)
void | put (rownr_t rownr, const String *dataPtr)
void | put (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | throwGet () const
| Throw an "invalid operation" exception for the default implementation of get.
void | throwPut () const
| Throw an "invalid operation" exception for the default implementation of put.
void | setColumnName (const String &colName)
| Set the column name.
const String & | columnName () const
| Get rhe column name.

## Protected Member Functions

void | basePrepare (const Table &thisTable, Bool writable)
| Do the preparation of the base class column object.
BaseColumn * | colPtr () const
Protected Member Functions inherited from casacore::DataManagerColumn
void | getScalarColumnBase (ArrayBase &dataPtr)
| The default implementations of get and put functions.
void | putScalarColumnBase (const ArrayBase &dataPtr)
void | getScalarColumnCellsBase (const RefRows &rownrs, ArrayBase &dataPtr)
void | putScalarColumnCellsBase (const RefRows &rownrs, const ArrayBase &dataPtr)
void | getArrayColumnBase (ArrayBase &data)
void | putArrayColumnBase (const ArrayBase &data)
void | getArrayColumnCellsBase (const RefRows &rownrs, ArrayBase &data)
void | putArrayColumnCellsBase (const RefRows &rownrs, const ArrayBase &data)
void | getSliceBase (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
void | putSliceBase (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceBase (const Slicer &slicer, ArrayBase &data)
void | putColumnSliceBase (const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
void | putColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)

## Private Member Functions

Bool | canChangeShape () const
| This data manager may be able to handle changing array shapes.
int | dataType () const
| Get the data type of the column as defined in DataType.h.
String | dataTypeId () const
| Get the data type id of the column for dataType==TpOther.
Bool | isWritable () const
| Test if data can be put into this column.
void | setShapeColumn (const IPosition &shape)
| Set the shape of an direct array.
void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of an (indirect) array in the given row.
Bool | isShapeDefined (rownr_t rownr)
| Is the value shape defined in the given row?
uInt | ndim (rownr_t rownr)
| Get the dimensionality of the item in the given row.
IPosition | shape (rownr_t rownr)
| Get the shape of the item in the given row.
virtual void | getBool (rownr_t rownr, Bool *dataPtr)
| Get the scalar value with a standard data type in the given row.
virtual void | getuChar (rownr_t rownr, uChar *dataPtr)
virtual void | getShort (rownr_t rownr, Short *dataPtr)
virtual void | getuShort (rownr_t rownr, uShort *dataPtr)
virtual void | getInt (rownr_t rownr, Int *dataPtr)
virtual void | getuInt (rownr_t rownr, uInt *dataPtr)
virtual void | getInt64 (rownr_t rownr, Int64 *dataPtr)
virtual void | getfloat (rownr_t rownr, float *dataPtr)
virtual void | getdouble (rownr_t rownr, double *dataPtr)
virtual void | getComplex (rownr_t rownr, Complex *dataPtr)
virtual void | getDComplex (rownr_t rownr, DComplex *dataPtr)
virtual void | getString (rownr_t rownr, String *dataPtr)
virtual void | getOther (rownr_t rownr, void *dataPtr)
| Get the scalar value with a non-standard data type in the given row.
virtual void | putBool (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value with a standard data type into the given row.
virtual void | putuChar (rownr_t rownr, const uChar *dataPtr)
virtual void | putShort (rownr_t rownr, const Short *dataPtr)
virtual void | putuShort (rownr_t rownr, const uShort *dataPtr)
virtual void | putInt (rownr_t rownr, const Int *dataPtr)
virtual void | putuInt (rownr_t rownr, const uInt *dataPtr)
virtual void | putInt64 (rownr_t rownr, const Int64 *dataPtr)
virtual void | putfloat (rownr_t rownr, const float *dataPtr)
virtual void | putdouble (rownr_t rownr, const double *dataPtr)
virtual void | putComplex (rownr_t rownr, const Complex *dataPtr)
virtual void | putDComplex (rownr_t rownr, const DComplex *dataPtr)
virtual void | putString (rownr_t rownr, const String *dataPtr)
virtual void | putOther (rownr_t rownr, const void *dataPtr)
| Put the scalar value with a non-standard data type into the given row.
void | getScalarColumnV (ArrayBase &dataPtr)
| Get all scalar values in the column.
void | putScalarColumnV (const ArrayBase &dataPtr)
| Put all scalar values in the column.
virtual void | getScalarColumnCellsV (const RefRows &rownrs, ArrayBase &dataPtr)
| Get some scalar values in the column.
virtual void | putScalarColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr)
| Put some scalar values in the column.
void | getArrayV (rownr_t rownr, ArrayBase &dataPtr)
| Get the array value in the given row.
void | putArrayV (rownr_t rownr, const ArrayBase &dataPtr)
| Put the array value into the given row.
void | getSliceV (rownr_t rownr, const Slicer &slicer, ArrayBase &dataPtr)
| Get a section of the array in the given row.
void | putSliceV (rownr_t rownr, const Slicer &slicer, const ArrayBase &dataPtr)
| Put into a section of the array in the given row.
void | getArrayColumnV (ArrayBase &dataPtr)
| Get all scalar values in the column.
void | putArrayColumnV (const ArrayBase &dataPtr)
| Put all scalar values in the column.
virtual void | getArrayColumnCellsV (const RefRows &rownrs, ArrayBase &dataPtr)
| Get some array values in the column.
virtual void | putArrayColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr)
| Put some array values in the column.
void | getColumnSliceV (const Slicer &slicer, ArrayBase &dataPtr)
| Get a section of all arrays in the column.
void | putColumnSliceV (const Slicer &slicer, const ArrayBase &dataPtr)
| Put a section into all arrays in the column.
virtual void | getColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, ArrayBase &dataPtr)
| Get a section of some arrays in the column.
virtual void | putColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &dataPtr)
| Put into a section of some arrays in the column.

## Static Private Member Functions

static SetupNewTable | setupNewTable (const Table &table, const String &tableName, Table::TableOption option)
| Create a SetupNewTable object with the given name and option and with the description from the given table.

## Private Attributes

ForwardColumnEngine * | enginePtr_p
String | colName_p
int | dataType_p
String | dataTypeId_p
TableColumn | refCol_p
Bool | writable_p
Table | origTable_p
BaseColumn * | colPtr_p

## Detailed Description

Virtual column forwarding to another column

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Intended use:

Internal

### Prerequisite

- ForwardColumnEngine
- DataManagerColumn

### Synopsis

ForwardColumn represents a virtual column which forwards the gets and puts to a column with the same name in another table. It is, in fact, a reference to the other column. The name of the other table is stored as a keyword in the forwarding column. When there is a forwarding chain (i.e. forwarding to a forwarding column), the name of the last table in the chain is stored in the keyword. In this way, the length of the chain is kept to a minimum. Otherwise a very long chain could occur, which would slow things down.

Addition and deletion of rows is allowed, but the functions addRow and removeRow do not do anything at all. They are implemented to override the default "throw exception" implementation. Because the engine allows this, it can be used in a table supporting addition and removal of rows.

An object of this class is created (and deleted) by ForwardColumnEngine which creates a ForwardColumn object for each column being forwarded.

### Motivation

This class will be used by the calibration software. Most columns in a measurement table will be forwarded, while a few (i.e. the data themselves) will be calculated by a dedicated calibration engine.

Definition at line 89 of file ForwardCol.h.

## Constructor & Destructor Documentation

## ForwardColumn() [1/2]

casacore::ForwardColumn::ForwardColumn | ( | ForwardColumnEngine * | enginePtr,
|  | const String & | columnName,
|  | int | dataType,
|  | const String & | dataTypeId,
|  | const Table & | referencedTable )

Construct it for the given column.

References casacore::DataManagerColumn::columnName(), dataType(), and dataTypeId().

Referenced by ForwardColumn(), and operator=().

## ~ForwardColumn()

virtual casacore::ForwardColumn::~ForwardColumn | ( |  | ) |

virtual

Destructor is mandatory.

## ForwardColumn() [2/2]

casacore::ForwardColumn::ForwardColumn | ( | const ForwardColumn & |  | ) |

delete

Copy constructor is not needed and therefore forbidden.

References ForwardColumn().

## Member Function Documentation

## basePrepare()

void casacore::ForwardColumn::basePrepare | ( | const Table & | thisTable,
|  | Bool | writable )

protected

Do the preparation of the base class column object.

## canChangeShape()

Bool casacore::ForwardColumn::canChangeShape | ( |  | ) | const

private virtual

This data manager may be able to handle changing array shapes.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## colPtr()

BaseColumn * casacore::ForwardColumn::colPtr | ( |  | ) | const

inline protected

Definition at line 131 of file ForwardCol.h.

References colPtr_p.

## dataType()

int casacore::ForwardColumn::dataType | ( |  | ) | const

private virtual

Get the data type of the column as defined in DataType.h.

Implements casacore::DataManagerColumn.

Referenced by ForwardColumn(), and casacore::ForwardColumnIndexedRow::ForwardColumnIndexedRow().

## dataTypeId()

String casacore::ForwardColumn::dataTypeId | ( |  | ) | const

private virtual

Get the data type id of the column for dataType==TpOther.

This function is required for virtual column engines handling non-standard data types. It is used to check the data type.

Reimplemented from casacore::DataManagerColumn.

Referenced by ForwardColumn(), and casacore::ForwardColumnIndexedRow::ForwardColumnIndexedRow().

## fillTableName()

void casacore::ForwardColumn::fillTableName | ( | const Table & | thisTable,
|  | const Table & | referencedTable )

Define the special keyword containing the name of the original table.

If the column in the referenced table contains that special keyword, it is in its turn a forwarding column. In that case the special keyword value will be copied over to shortcut the forwarding chain. The suffix is appended to the keyword name when defining it. This makes this function usable for derived classes.

## getArrayColumnCellsV()

virtual void casacore::ForwardColumn::getArrayColumnCellsV | ( | const RefRows & | rownrs,
|  | ArrayBase & | dataPtr )

private virtual

Get some array values in the column.

The argument dataPtr is in fact an Array<T>&, but a ArrayBase& is needed to be generic. The vector pointed to by dataPtr has to have the correct length (which is guaranteed by the ArrayColumn getColumn function).

Reimplemented from casacore::DataManagerColumn.

## getArrayColumnV()

void casacore::ForwardColumn::getArrayColumnV | ( | ArrayBase & | dataPtr | ) |

private virtual

Get all scalar values in the column.

The argument dataPtr is in fact a Vector<T>&, but a ArrayBase& is needed to be generic. The vector pointed to by dataPtr has to have the correct length (which is guaranteed by the ScalarColumn getColumn function).

Reimplemented from casacore::DataManagerColumn.

## getArrayV()

void casacore::ForwardColumn::getArrayV | ( | rownr_t | rownr,
|  | ArrayBase & | dataPtr )

private virtual

Get the array value in the given row.

The argument dataPtr is in fact a Array<T>&, but a ArrayBase& is needed to be generic. The array pointed to by dataPtr has to have the correct shape (which is guaranteed by the ArrayColumn get function).

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getBool()

virtual void casacore::ForwardColumn::getBool | ( | rownr_t | rownr,
|  | Bool * | dataPtr )

private virtual

Get the scalar value with a standard data type in the given row.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getColumnSliceCellsV()

virtual void casacore::ForwardColumn::getColumnSliceCellsV | ( | const RefRows & | rownrs,
|  | const Slicer & | slicer,
|  | ArrayBase & | dataPtr )

private virtual

Get a section of some arrays in the column.

The argument dataPtr is in fact an Array<T>&, but a ArrayBase& is needed to be generic. The array pointed to by dataPtr has to have the correct shape (which is guaranteed by the ArrayColumn getColumn function).

Reimplemented from casacore::DataManagerColumn.

## getColumnSliceV()

void casacore::ForwardColumn::getColumnSliceV | ( | const Slicer & | slicer,
|  | ArrayBase & | dataPtr )

private virtual

Get a section of all arrays in the column.

The argument dataPtr is in fact a Array<T>&, but a ArrayBase& is needed to be generic. The array pointed to by dataPtr has to have the correct shape (which is guaranteed by the ArrayColumn getColumn function).

Reimplemented from casacore::DataManagerColumn.

## getComplex()

virtual void casacore::ForwardColumn::getComplex | ( | rownr_t | rownr,
|  | Complex * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getDComplex()

virtual void casacore::ForwardColumn::getDComplex | ( | rownr_t | rownr,
|  | DComplex * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getdouble()

virtual void casacore::ForwardColumn::getdouble | ( | rownr_t | rownr,
|  | double * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getfloat()

virtual void casacore::ForwardColumn::getfloat | ( | rownr_t | rownr,
|  | float * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getInt()

virtual void casacore::ForwardColumn::getInt | ( | rownr_t | rownr,
|  | Int * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getInt64()

virtual void casacore::ForwardColumn::getInt64 | ( | rownr_t | rownr,
|  | Int64 * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getOther()

virtual void casacore::ForwardColumn::getOther | ( | rownr_t | rownr,
|  | void * | dataPtr )

private virtual

Get the scalar value with a non-standard data type in the given row.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getScalarColumnCellsV()

virtual void casacore::ForwardColumn::getScalarColumnCellsV | ( | const RefRows & | rownrs,
|  | ArrayBase & | dataPtr )

private virtual

Get some scalar values in the column.

The argument dataPtr is in fact a Vector<T>&, but a ArrayBase& is needed to be generic. The vector pointed to by dataPtr has to have the correct length (which is guaranteed by the ScalarColumn getColumn function).

Reimplemented from casacore::DataManagerColumn.

## getScalarColumnV()

void casacore::ForwardColumn::getScalarColumnV | ( | ArrayBase & | dataPtr | ) |

private virtual

Get all scalar values in the column.

The argument dataPtr is in fact a Vector<T>&, but a ArrayBase& is needed to be generic. The vector pointed to by dataPtr has to have the correct length (which is guaranteed by the ScalarColumn getColumn function).

Reimplemented from casacore::DataManagerColumn.

## getShort()

virtual void casacore::ForwardColumn::getShort | ( | rownr_t | rownr,
|  | Short * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getSliceV()

void casacore::ForwardColumn::getSliceV | ( | rownr_t | rownr,
|  | const Slicer & | slicer,
|  | ArrayBase & | dataPtr )

private virtual

Get a section of the array in the given row.

The argument dataPtr is in fact a Array<T>&, but a ArrayBase& is needed to be generic. The array pointed to by dataPtr has to have the correct shape (which is guaranteed by the ArrayColumn getSlice function).

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getString()

virtual void casacore::ForwardColumn::getString | ( | rownr_t | rownr,
|  | String * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getuChar()

virtual void casacore::ForwardColumn::getuChar | ( | rownr_t | rownr,
|  | uChar * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getuInt()

virtual void casacore::ForwardColumn::getuInt | ( | rownr_t | rownr,
|  | uInt * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## getuShort()

virtual void casacore::ForwardColumn::getuShort | ( | rownr_t | rownr,
|  | uShort * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## isShapeDefined()

Bool casacore::ForwardColumn::isShapeDefined | ( | rownr_t | rownr | ) |

private virtual

Is the value shape defined in the given row?

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## isWritable()

Bool casacore::ForwardColumn::isWritable | ( |  | ) | const

private virtual

Test if data can be put into this column.

Reimplemented from casacore::DataManagerColumn.

## ndim()

uInt casacore::ForwardColumn::ndim | ( | rownr_t | rownr | ) |

private virtual

Get the dimensionality of the item in the given row.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## operator=()

ForwardColumn & casacore::ForwardColumn::operator= | ( | const ForwardColumn & |  | ) |

delete

Assignment is not needed and therefore forbidden.

References ForwardColumn().

## prepare()

virtual void casacore::ForwardColumn::prepare | ( | const Table & | thisTable | ) |

virtual

Initialize the object.

This means binding the column to the column with the same name in the original table. It checks if the description of both columns is the same. It also determines if the column is writable.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putArrayColumnCellsV()

virtual void casacore::ForwardColumn::putArrayColumnCellsV | ( | const RefRows & | rownrs,
|  | const ArrayBase & | dataPtr )

private virtual

Put some array values in the column.

The argument dataPtr is in fact an const Array<T>&, but a const ArrayBase& is needed to be generic. The vector pointed to by dataPtr has to have the correct length (which is guaranteed by the ArrayColumn getColumn function).

Reimplemented from casacore::DataManagerColumn.

## putArrayColumnV()

void casacore::ForwardColumn::putArrayColumnV | ( | const ArrayBase & | dataPtr | ) |

private virtual

Put all scalar values in the column.

The argument dataPtr is in fact a const Vector<T>&, but a const ArrayBase& is needed to be generic. The vector pointed to by dataPtr has to have the correct length (which is guaranteed by the ScalarColumn putColumn function).

Reimplemented from casacore::DataManagerColumn.

## putArrayV()

void casacore::ForwardColumn::putArrayV | ( | rownr_t | rownr,
|  | const ArrayBase & | dataPtr )

private virtual

Put the array value into the given row.

The argument dataPtr is in fact a const Array<T>&, but a const ArrayBase& is needed to be generic. The array pointed to by dataPtr has to have the correct shape (which is guaranteed by the ArrayColumn put function).

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putBool()

virtual void casacore::ForwardColumn::putBool | ( | rownr_t | rownr,
|  | const Bool * | dataPtr )

private virtual

Put the scalar value with a standard data type into the given row.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putColumnSliceCellsV()

virtual void casacore::ForwardColumn::putColumnSliceCellsV | ( | const RefRows & | rownrs,
|  | const Slicer & | slicer,
|  | const ArrayBase & | dataPtr )

private virtual

Put into a section of some arrays in the column.

The argument dataPtr is in fact a const Array<T>&, but a const ArrayBase& is needed to be generic. The array pointed to by dataPtr has to have the correct shape (which is guaranteed by the ArrayColumn putColumn function).

Reimplemented from casacore::DataManagerColumn.

## putColumnSliceV()

void casacore::ForwardColumn::putColumnSliceV | ( | const Slicer & | slicer,
|  | const ArrayBase & | dataPtr )

private virtual

Put a section into all arrays in the column.

The argument dataPtr is in fact a const Array<T>&, but a const ArrayBase& is needed to be generic. The array pointed to by dataPtr has to have the correct shape (which is guaranteed by the ArrayColumn putColumn function).

Reimplemented from casacore::DataManagerColumn.

## putComplex()

virtual void casacore::ForwardColumn::putComplex | ( | rownr_t | rownr,
|  | const Complex * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putDComplex()

virtual void casacore::ForwardColumn::putDComplex | ( | rownr_t | rownr,
|  | const DComplex * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putdouble()

virtual void casacore::ForwardColumn::putdouble | ( | rownr_t | rownr,
|  | const double * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putfloat()

virtual void casacore::ForwardColumn::putfloat | ( | rownr_t | rownr,
|  | const float * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putInt()

virtual void casacore::ForwardColumn::putInt | ( | rownr_t | rownr,
|  | const Int * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putInt64()

virtual void casacore::ForwardColumn::putInt64 | ( | rownr_t | rownr,
|  | const Int64 * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putOther()

virtual void casacore::ForwardColumn::putOther | ( | rownr_t | rownr,
|  | const void * | dataPtr )

private virtual

Put the scalar value with a non-standard data type into the given row.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putScalarColumnCellsV()

virtual void casacore::ForwardColumn::putScalarColumnCellsV | ( | const RefRows & | rownrs,
|  | const ArrayBase & | dataPtr )

private virtual

Put some scalar values in the column.

The argument dataPtr is in fact a const Vector<T>&, but a const ArrayBase& is needed to be generic. The vector pointed to by dataPtr has to have the correct length (which is guaranteed by the ScalarColumn getColumn function).

Reimplemented from casacore::DataManagerColumn.

## putScalarColumnV()

void casacore::ForwardColumn::putScalarColumnV | ( | const ArrayBase & | dataPtr | ) |

private virtual

Put all scalar values in the column.

The argument dataPtr is in fact a const Vector<T>&, but a const ArrayBase& is needed to be generic. The vector pointed to by dataPtr has to have the correct length (which is guaranteed by the ScalarColumn putColumn function).

Reimplemented from casacore::DataManagerColumn.

## putShort()

virtual void casacore::ForwardColumn::putShort | ( | rownr_t | rownr,
|  | const Short * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putSliceV()

void casacore::ForwardColumn::putSliceV | ( | rownr_t | rownr,
|  | const Slicer & | slicer,
|  | const ArrayBase & | dataPtr )

private virtual

Put into a section of the array in the given row.

The argument dataPtr is in fact a const Array<T>&, but a const ArrayBase& is needed to be generic. The array pointed to by dataPtr has to have the correct shape (which is guaranteed by the ArrayColumn putSlice function).

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putString()

virtual void casacore::ForwardColumn::putString | ( | rownr_t | rownr,
|  | const String * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putuChar()

virtual void casacore::ForwardColumn::putuChar | ( | rownr_t | rownr,
|  | const uChar * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putuInt()

virtual void casacore::ForwardColumn::putuInt | ( | rownr_t | rownr,
|  | const uInt * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## putuShort()

virtual void casacore::ForwardColumn::putuShort | ( | rownr_t | rownr,
|  | const uShort * | dataPtr )

private virtual

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

## setRW()

void casacore::ForwardColumn::setRW | ( |  | ) |

Set the column to writable if its underlying table is writable.

## setShape()

void casacore::ForwardColumn::setShape | ( | rownr_t | rownr,
|  | const IPosition & | shape )

private virtual

Set the shape of an (indirect) array in the given row.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

References shape().

## setShapeColumn()

void casacore::ForwardColumn::setShapeColumn | ( | const IPosition & | shape | ) |

private virtual

Set the shape of an direct array.

This only checks if the shape matches the referenced column.

Reimplemented from casacore::DataManagerColumn.

References shape().

## setupNewTable()

SetupNewTable casacore::ForwardColumn::setupNewTable | ( | const Table & | table,
|  | const String & | tableName,
|  | Table::TableOption | option )

static private

Create a SetupNewTable object with the given name and option and with the description from the given table.

The SetupNewTable object will use a single ForwardColumn engine which forwards all columns to the given table. Later the SetupNewTable::bind functions can be used to bind one or more columns to another data manager.

## shape()

IPosition casacore::ForwardColumn::shape | ( | rownr_t | rownr | ) |

private virtual

Get the shape of the item in the given row.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::ForwardColumnIndexedRow.

Referenced by setShape(), and setShapeColumn().

## Member Data Documentation

## colName_p

String casacore::ForwardColumn::colName_p

private

Definition at line 335 of file ForwardCol.h.

## colPtr_p

BaseColumn* casacore::ForwardColumn::colPtr_p

private

Definition at line 343 of file ForwardCol.h.

Referenced by colPtr().

## dataType_p

int casacore::ForwardColumn::dataType_p

private

Definition at line 336 of file ForwardCol.h.

## dataTypeId_p

String casacore::ForwardColumn::dataTypeId_p

private

Definition at line 337 of file ForwardCol.h.

## enginePtr_p

ForwardColumnEngine* casacore::ForwardColumn::enginePtr_p

private

Definition at line 334 of file ForwardCol.h.

## origTable_p

Table casacore::ForwardColumn::origTable_p

private

Definition at line 342 of file ForwardCol.h.

## refCol_p

TableColumn casacore::ForwardColumn::refCol_p

private

Definition at line 338 of file ForwardCol.h.

## writable_p

Bool casacore::ForwardColumn::writable_p

private

Definition at line 341 of file ForwardCol.h.

The documentation for this class was generated from the following file:

- tables/DataMan/ForwardCol.h